/*
 *        HttFXlib.c 1.4 91/09/01  
 * 
 * Derived from FXlib.c	2.1 91/08/13 11:28:27 FUJITSU LIMITED. */
/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Takashi Fujiwara	FUJITSU LIMITED
				fujiwara@a80.tech.yk.fujitsu.co.jp
	Kiyoaki oya		FUJITSU LIMITED
	Riki	Kawaguchi	FUJITSU LIMITED
	Tomoki	Kuriki		FUJITSU LIMITED
	Hideki  Hiura           (hhiura@Sun.COM) Sun Microsystems, Inc.

****************************************************************************
*/

#ifndef lint
#ident  "@(#)HttFXlib.c	1.27    93/02/12 SMI"
static char     derived_sccs_id[] = "FXlib.c	2.1 91/08/13 11:28:27 FUJITSU LIMITED.";
#endif

#include <stdio.h>
#include "Htt.h"

#ifdef SVR4
#include <libintl.h>
#endif

extern htt_t	 *htt;
extern void	 FXDrawImageChar();
extern void	 DestroyPreeditInfo();
extern void	 HttDrawXIMString();

static void	DisablePreeditInfo();

static unsigned char pattern_bits [] = {
        0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa };

Pixmap                  stipple_pixmap;

#ifdef	USE_X11R5_LIB
int
FXLoadQueryBaseFont(display, current_preedit_font, base_font_name)
    Display        *display;
    FXimpFont      *current_preedit_font;
    char           *base_font_name;
{
    char		**miss_name_return ;
    char		**def_string_return ;
    int			  miss_count_return = 0 ;
    XFontSet		  font_set ;
    XFontSetExtents	 *fset_extents = NULL ;
    XRectangle		 *font_rect ;

#ifdef	DEBUG
    (void)dbg_printf( "*** FXLoadQueryBaseFont Start ***\n" ) ;
#endif	/* DEBUG */
    font_set = XCreateFontSet( display, base_font_name,
		    &miss_name_return, &miss_count_return, &def_string_return ) ;
#ifdef	DEBUG
    (void)dbg_printf( "  miss_count : %d\n", miss_count_return ) ;
#endif	/* DEBUG */

    if ( ( miss_count_return ) || ( !font_set ) ) {
#ifdef SVR4
        fprintf(stderr,dgettext("SUNW_XIM_HTT_MSG",
                   "htt: can not create fontset.\n"));
#else /* SVR4 */
        fprintf(stderr,"htt: can not create fontset.\n");
#endif /* SVR4 */
	return ( -1 ) ;
    }

    current_preedit_font->font_set = font_set ;
    current_preedit_font->status = FF_FONT_LOAD;

    fset_extents = XExtentsOfFontSet( font_set ) ;
    font_rect = &fset_extents->max_logical_extent ;

    current_preedit_font->max_font_width  = font_rect->width ;
    current_preedit_font->max_font_height = font_rect->height ;
    current_preedit_font->max_font_ascent = 0 - font_rect->y ;
    current_preedit_font->max_font_descent = font_rect->height + font_rect->y ;
#ifdef	DEBUG
    (void)dbg_printf( "*** FXLoadQueryBaseFont Norm return ***\n" ) ;
    (void)dbg_printf( "    width=%d height=%d ascent=%d descent=%d\n",
				current_preedit_font->max_font_width,
				current_preedit_font->max_font_height,
				current_preedit_font->max_font_ascent,
				current_preedit_font->max_font_descent );
#endif	/* DEBUG */
    return (0);
}

int
FXFreeFont(display, current_preedit_font)
    Display        *display;
    FXimpFont      *current_preedit_font;
{
    if (!(current_preedit_font->status & FF_FONT_LOAD))
	return (0);

    current_preedit_font->status &= ~FF_FONT_LOAD;
    XFreeFontSet( display, current_preedit_font->font_set ) ;
    return (0);
}

int
FXCreateGC(display, window, current_preedit_font,
	   foreground_pixel, background_pixel)
    Display        *display;
    Window          window;
    FXimpFont      *current_preedit_font;
    unsigned long   foreground_pixel, background_pixel;
{
    unsigned long   gcmask;
    XGCValues       gcvalues, reverse_gcvalues;

    gcmask = GCBackground | GCForeground | GCFunction ;
    gcvalues.function = GXcopy;
    gcvalues.foreground = foreground_pixel;
    gcvalues.background = background_pixel;
    reverse_gcvalues.function = GXcopy;
    reverse_gcvalues.foreground = background_pixel;
    reverse_gcvalues.background = foreground_pixel;

    current_preedit_font->normal_gc
	= XCreateGC(display, window, gcmask, &gcvalues);
    current_preedit_font->reverse_gc
	= XCreateGC(display, window, gcmask, &reverse_gcvalues);

    gcvalues.function = GXxor;
    gcvalues.foreground = background_pixel ^ foreground_pixel;
    gcvalues.plane_mask = background_pixel ^ foreground_pixel;
    gcmask = GCForeground | GCFunction | GCPlaneMask;
    current_preedit_font->invert_gc
	= XCreateGC(display, window, gcmask, &gcvalues);
    current_preedit_font->status |= FF_CREATE_GC;
    return (0);
}

int
FXFreeGC(display, current_preedit_font)
    Display        *display;
    FXimpFont      *current_preedit_font;
{
    if (current_preedit_font->status & FF_CREATE_GC) {
#define M_FreeGC( gc ) if( gc ) { XFreeGC( display, gc ); gc = 0; }

	M_FreeGC(current_preedit_font->normal_gc);
	M_FreeGC(current_preedit_font->reverse_gc);
	M_FreeGC(current_preedit_font->invert_gc);
#undef  M_FreeGC
    }
    return (0);
}

int
FXChangeGC(display, window, current_preedit_font,
	   foreground_pixel, background_pixel)
    Display        *display;
    Window          window;
    FXimpFont      *current_preedit_font;
    unsigned long   foreground_pixel, background_pixel;
{
    unsigned long   gcmask;
    XGCValues       gcvalues, reverse_gcvalues;
    if ((current_preedit_font->status & FF_CREATE_GC) == (unsigned char) 0) {
	return FXCreateGC(display, window, current_preedit_font,
			  foreground_pixel, background_pixel);
    }
    gcmask = GCBackground | GCForeground ;
    gcvalues.foreground = foreground_pixel;
    gcvalues.background = background_pixel;
    reverse_gcvalues.foreground = background_pixel;
    reverse_gcvalues.background = foreground_pixel;

    XChangeGC(display, current_preedit_font->normal_gc, gcmask, &gcvalues);
    XChangeGC(display, current_preedit_font->reverse_gc, gcmask,
	      &reverse_gcvalues);

    gcvalues.function = GXxor;
    gcvalues.foreground = background_pixel ^ foreground_pixel;
    gcvalues.plane_mask = background_pixel ^ foreground_pixel;
    gcmask = GCForeground | GCFunction | GCPlaneMask;
    XChangeGC(display, current_preedit_font->invert_gc, gcmask, &gcvalues);
    return (0);
}

int
FXTextWidth(current_preedit_font, input_data, length)
    FXimpFont      *current_preedit_font;
    wchar_t        *input_data;
    int             length;
{
    int		width = 0 ;

    if ( length )
	width = XwcTextEscapement( current_preedit_font->font_set,
				input_data, length ) ;
    return ( width ) ;
}

void
FXDrawString(display, window, current_preedit_font,
		  reverse, x, y, buff, length)
    Display	*display;
    Window	 window;
    FXimpFont	*current_preedit_font;
    int		 reverse;
    int		 x, y;
    wchar_t	*buff;
    int		 length;
{
    GC		 gc ;
#ifdef	DEBUG
    (void)dbg_printf( "*** FXImageString Start ***\n" ) ;
#endif	/* DEBUG */

    if ( !length )
	return ;

    if ( reverse ) {
	gc = current_preedit_font->reverse_gc ;
    } else {
	gc = current_preedit_font->normal_gc ;
    }

    XwcDrawString( display, window,
		    current_preedit_font->font_set, gc, x, y, buff, length ) ;

    return ;
}

void
FXDrawImageString(display, window, current_preedit_font,
		  reverse, x, y, buff, length, mode)
    Display	*display;
    Window	 window;
    FXimpFont	*current_preedit_font;
    int		 reverse;
    int		 x, y;
    wchar_t	*buff;
    int		 length;
    int		mode;
{
    GC		 gc ;
    XGCValues	 gcv;

    FXimp_Client *focus_in_client= GET_HTT_VALUE(htt, focus_in_client);
#ifdef	DEBUG
    (void)dbg_printf( "*** FXImageString Start ***\n" ) ;
#endif	/* DEBUG */

    if ( !length )
	return ;

    if ( reverse ) {
	XRectangle	 overall_ink_return, overall_logical_return ;
	XRectangle	*ink =     &overall_ink_return,
			*logical = &overall_logical_return ;
	gc = current_preedit_font->reverse_gc ;
	(void)XwcTextExtents( current_preedit_font->font_set,
			buff, length, ink, logical ) ;
#ifdef	DEBUG
    (void)dbg_printf( " ** XwcTextExteents return **\n" ) ;
    (void)dbg_printf( "    width=%d, height=%d, x=%d, y=%d\n",
			ink->width, ink->height, ink->x, ink->y );
#endif	/* DEBUG */
	XFillRectangle( display, window, current_preedit_font->normal_gc,
		x, y + ink->y,
		x + ink->width, y + ( ink->height + ink->y ) ) ;
    } else {
	gc = current_preedit_font->normal_gc ;
    }

    if (mode == stipple) {
	XGetGCValues(display, gc, GCForeground | GCBackground, &gcv);
        stipple_pixmap = XCreatePixmapFromBitmapData(display,
                window, (char *)pattern_bits, 8, 8,
                gcv.background, gcv.foreground, 1);
        XSetStipple(display, gc, stipple_pixmap);
        XSetFillStyle(display, gc, FillOpaqueStippled);
        XwcDrawString( display, window,
             current_preedit_font->font_set, gc, x, y, buff, length );
        XSetFillStyle(display, gc, FillSolid);
        XFreePixmap(display, stipple_pixmap);
    }
    else 
      if(gc)
          XwcDrawImageString( display, window,
		    current_preedit_font->font_set, gc, x, y, buff, length ) ;

    return ;
}

#else	/* USE_X11R5_LIB */
int
FXLoadQueryBaseFont(display, current_preedit_font, base_font_name)
    Display        *display;
    FXimpFont      *current_preedit_font;
    char           *base_font_name;
{
    XFontStruct    *ascii_kana_font_struct = 0,
		   *kanji_font_struct = 0,
		   *gaiji_font_struct = 0;
    char           *ascii_kana_font_name, *kanji_font_name, *gaiji_font_name;
    int             wfont_h, no = 0, ii;
    int             error = 0;
    char           *cfn, cc, *none, *none2, null = 0;
    XFontStruct    *font_struct, *font_struct_tbl[4];
    char           *cfnt[4], work[512];

    current_preedit_font->fixe_width = 1;
    if (!base_font_name || !*base_font_name)
	return (-2);

    cfn = work;
    cfnt[no++] = cfn;
    while ((cc = *base_font_name++) != NULL) {
	if (cc == ',') {
	    *cfn++ = NULL;
	    cfnt[no++] = cfn;
	} else
	    *cfn++ = cc;
    }
    *cfn = NULL;

    none = &null;
    none2 = &null;
    error = 0;
    for (ii = 0; ii < no; ii++) {
	font_struct = XLoadQueryFont(display, cfnt[ii]);
	if (!font_struct) {
	    ErrorMessage(30, cfnt[ii]);
	    continue;
	}
#ifdef DEBUG
	dbg_printf("XLoadQueryFont (%s)\n min_byte1=%d max_byte1=%d min_char_or_byte2=%d max_char_or_byte2=%d\n",
		   cfnt[ii], font_struct->min_byte1, font_struct->max_byte1,
	    font_struct->min_char_or_byte2, font_struct->max_char_or_byte2);
#endif				/* DEBUG */
	if (font_struct->min_byte1 == 0 || font_struct->max_byte1 == 0) {
	    if (font_struct->min_char_or_byte2 <= 0x20
		&& font_struct->max_char_or_byte2 == 0xDF) {
#ifdef DEBUG
		dbg_printf("  (ascii_kana_font_name)\n");
#endif				/* DEBUG */
		if (ascii_kana_font_struct) {
#ifdef DEBUG
		    dbg_printf("  reload ! ascii_kana_font_name\n");
#endif				/* DEBUG */
		    XFreeFont(display, ascii_kana_font_struct);
		}
		ascii_kana_font_struct = font_struct;
		ascii_kana_font_name = cfnt[ii];
	    } else {
#ifdef DEBUG
		dbg_printf("  not ! ascii_kana_font_name (%s)\n", cfnt[ii]);
#endif				/* DEBUG */
		none = cfnt[ii];
		XFreeFont(display, font_struct);
	    }
	} else {
	    if (font_struct->min_byte1 <= 0x20
		|| font_struct->max_byte1 >= 0x40) {
#ifdef DEBUG
		dbg_printf("  (kanji_font_name)\n");
#endif				/* DEBUG */
		if (kanji_font_struct) {
#ifdef DEBUG
		    dbg_printf("  reload ! kanji_font_name\n");
#endif				/* DEBUG */
		    XFreeFont(display, kanji_font_struct);
		}
		kanji_font_struct = font_struct;
		kanji_font_name = cfnt[ii];
	    } else {
#ifdef DEBUG
		dbg_printf("  gaiji_font_name (%s)\n", cfnt[ii]);
#endif				/* DEBUG */
		if (!gaiji_font_struct) {
#ifdef DEBUG
		    dbg_printf("  reload ! gaiji_font_name\n");
#endif				/* DEBUG */
		    XFreeFont(display, gaiji_font_struct);
		}
		gaiji_font_struct = font_struct;
		gaiji_font_name = cfnt[ii];
	    }
	}
    }

    if (!ascii_kana_font_struct) {
	ErrorMessage(32);
	error = 1;
    }
    if (!kanji_font_struct) {
	ErrorMessage(34);
	error = 1;
    }
    if (error) {
	if (ascii_kana_font_struct)
	    XFreeFont(display, ascii_kana_font_struct);
	if (kanji_font_struct)
	    XFreeFont(display, kanji_font_struct);
	if (gaiji_font_struct)
	    XFreeFont(display, gaiji_font_struct);
#ifdef DEBUG
	dbg_printf("  XLoadQueryFont Error EXIT !!\n");
#endif				/* DEBUG */
	return (-1);
    }
    if (ascii_kana_font_struct->per_char)
	current_preedit_font->fixe_width = 0;
    if (kanji_font_struct->per_char)
	current_preedit_font->fixe_width = 0;
    if (gaiji_font_struct && gaiji_font_struct->per_char)
	current_preedit_font->fixe_width = 0;

    current_preedit_font->ascii_kana_font_struct = ascii_kana_font_struct;
    current_preedit_font->status = FF_FONT_LOAD;
    current_preedit_font->kanji_font_struct = kanji_font_struct;
    current_preedit_font->gaiji_font_struct = gaiji_font_struct;
    current_preedit_font->ascii_kana_font_width
	= ascii_kana_font_struct->max_bounds.width;
    current_preedit_font->max_font_ascent
	= (ascii_kana_font_struct->ascent > kanji_font_struct->ascent) ?
	ascii_kana_font_struct->ascent : kanji_font_struct->ascent;
    current_preedit_font->max_font_descent
	= (ascii_kana_font_struct->descent > kanji_font_struct->descent) ?
	ascii_kana_font_struct->descent : kanji_font_struct->descent;
    current_preedit_font->max_font_height
	= ascii_kana_font_struct->ascent + ascii_kana_font_struct->descent;
    wfont_h = kanji_font_struct->ascent + kanji_font_struct->descent;
    if (current_preedit_font->max_font_height < wfont_h)
	current_preedit_font->max_font_height = wfont_h;
    current_preedit_font->kanji_font_width = kanji_font_struct->max_bounds.width;
#ifdef	XSF_X11R5
    current_preedit_font->max_font_width = current_preedit_font->kanji_font_width;
#endif
    return (0);
}

int
FXFreeFont(display, current_preedit_font)
    Display        *display;
    FXimpFont      *current_preedit_font;
{
    if (!(current_preedit_font->status & FF_FONT_LOAD))
	return (0);

    if (current_preedit_font->ascii_kana_font_struct) {
	XFreeFont(display, current_preedit_font->ascii_kana_font_struct);
	current_preedit_font->ascii_kana_font_struct = 0;
    }
    if (current_preedit_font->kanji_font_struct) {
	XFreeFont(display, current_preedit_font->kanji_font_struct);
	current_preedit_font->kanji_font_struct = 0;
    }
    if (current_preedit_font->gaiji_font_struct) {
	XFreeFont(display, current_preedit_font->gaiji_font_struct);
	current_preedit_font->gaiji_font_struct = 0;
    }
    return (0);
}

int
FXCreateGC(display, window, current_preedit_font,
	   foreground_pixel, background_pixel)
    Display        *display;
    Window          window;
    FXimpFont      *current_preedit_font;
    unsigned long   foreground_pixel, background_pixel;
{
    unsigned long   gcmask;
    XGCValues       gcvalues, reverse_gcvalues;

    gcmask = GCBackground | GCForeground | GCFont;
    gcvalues.foreground = foreground_pixel;
    gcvalues.background = background_pixel;
    reverse_gcvalues.foreground = background_pixel;
    reverse_gcvalues.background = foreground_pixel;

    gcvalues.font = current_preedit_font->ascii_kana_font_struct->fid;
    reverse_gcvalues.font = current_preedit_font->ascii_kana_font_struct->fid;
    current_preedit_font->ascii_kana_gc
	= XCreateGC(display, window, gcmask, &gcvalues);
    current_preedit_font->ascii_kana_reverse_gc
	= XCreateGC(display, window, gcmask, &reverse_gcvalues);

    gcvalues.font = current_preedit_font->kanji_font_struct->fid;
    reverse_gcvalues.font = current_preedit_font->kanji_font_struct->fid;
    current_preedit_font->kanji_gc
	= XCreateGC(display, window, gcmask, &gcvalues);
    current_preedit_font->kanji_reverse_gc
	= XCreateGC(display, window, gcmask, &reverse_gcvalues);

    if (current_preedit_font->gaiji_font_struct) {
	gcvalues.font = current_preedit_font->gaiji_font_struct->fid;
	reverse_gcvalues.font = current_preedit_font->gaiji_font_struct->fid;
	current_preedit_font->gaiji_gc
	    = XCreateGC(display, window, gcmask, &gcvalues);
	current_preedit_font->gaiji_reverse_gc
	    = XCreateGC(display, window, gcmask, &reverse_gcvalues);
    }
    gcvalues.function = GXxor;
    gcvalues.foreground = background_pixel ^ foreground_pixel;
    gcvalues.plane_mask = background_pixel ^ foreground_pixel;
    gcmask = GCForeground | GCFunction | GCPlaneMask;
    current_preedit_font->invert_gc
	= XCreateGC(display, window, gcmask, &gcvalues);
#ifdef	XSF_X11R5
    gcmask = GCBackground | GCForeground | GCFunction ;
    gcvalues.function = GXcopy;
    gcvalues.foreground = foreground_pixel;
    gcvalues.background = background_pixel;
    reverse_gcvalues.function = GXcopy;
    reverse_gcvalues.foreground = background_pixel;
    reverse_gcvalues.background = foreground_pixel;

    current_preedit_font->normal_gc
	= XCreateGC(display, window, gcmask, &gcvalues);
    current_preedit_font->reverse_gc
	= XCreateGC(display, window, gcmask, &reverse_gcvalues);
#endif	/* XSF_X11R5 */
    current_preedit_font->status |= FF_CREATE_GC;
    return (0);
}

int
FXFreeGC(display, current_preedit_font)
    Display        *display;
    FXimpFont      *current_preedit_font;
{
    if (current_preedit_font->status & FF_CREATE_GC) {
#define M_FreeGC( gc ) if( gc ) { XFreeGC( display, gc ); gc = 0; }

	M_FreeGC(current_preedit_font->ascii_kana_gc);
	M_FreeGC(current_preedit_font->kanji_gc);
	M_FreeGC(current_preedit_font->gaiji_gc);
	M_FreeGC(current_preedit_font->ascii_kana_reverse_gc);
	M_FreeGC(current_preedit_font->kanji_reverse_gc);
	M_FreeGC(current_preedit_font->gaiji_reverse_gc);
	M_FreeGC(current_preedit_font->invert_gc);
#ifdef	XSF_X11R5
	M_FreeGC( current_preedit_font->normal_gc );
	M_FreeGC( current_preedit_font->reverse_gc );
#endif	/* XSF_X11R5 */
#undef  M_FreeGC
    }
    return (0);
}

int
FXChangeGC(display, window, current_preedit_font,
	   foreground_pixel, background_pixel)
    Display        *display;
    Window          window;
    FXimpFont      *current_preedit_font;
    unsigned long   foreground_pixel, background_pixel;
{
    unsigned long   gcmask;
    XGCValues       gcvalues, reverse_gcvalues;
    if ((current_preedit_font->status & FF_CREATE_GC) == (unsigned char) 0) {
	return FXCreateGC(display, window, current_preedit_font,
			  foreground_pixel, background_pixel);
    }
    gcmask = GCBackground | GCForeground | GCFont;
    gcvalues.foreground = foreground_pixel;
    gcvalues.background = background_pixel;
    reverse_gcvalues.foreground = background_pixel;
    reverse_gcvalues.background = foreground_pixel;

    gcvalues.font = current_preedit_font->ascii_kana_font_struct->fid;
    reverse_gcvalues.font = current_preedit_font->ascii_kana_font_struct->fid;
    XChangeGC(display, current_preedit_font->ascii_kana_gc, gcmask, &gcvalues);
    XChangeGC(display, current_preedit_font->ascii_kana_reverse_gc, gcmask,
	      &reverse_gcvalues);
    gcvalues.font = current_preedit_font->kanji_font_struct->fid;
    reverse_gcvalues.font = current_preedit_font->kanji_font_struct->fid;
    XChangeGC(display, current_preedit_font->kanji_gc, gcmask, &gcvalues);
    XChangeGC(display, current_preedit_font->kanji_reverse_gc, gcmask,
	      &reverse_gcvalues);

    if (current_preedit_font->gaiji_font_struct) {
	gcvalues.font = current_preedit_font->gaiji_font_struct->fid;
	reverse_gcvalues.font = current_preedit_font->gaiji_font_struct->fid;
	if (current_preedit_font->gaiji_gc) {
	    XChangeGC(display, current_preedit_font->gaiji_gc, gcmask, &gcvalues);
	    XChangeGC(display, current_preedit_font->gaiji_reverse_gc, gcmask,
		      &reverse_gcvalues);
	} else {
	    current_preedit_font->gaiji_gc
		= XCreateGC(display, window, gcmask, &gcvalues);
	    current_preedit_font->gaiji_reverse_gc
		= XCreateGC(display, window, gcmask, &reverse_gcvalues);
	}
    } else {
	if (current_preedit_font->gaiji_gc) {
	    XFreeGC(display, current_preedit_font->gaiji_gc);
	    XFreeGC(display, current_preedit_font->gaiji_reverse_gc);
	    current_preedit_font->gaiji_gc = 0;
	    current_preedit_font->gaiji_reverse_gc = 0;
	}
    }

    gcvalues.function = GXxor;
    gcvalues.foreground = background_pixel ^ foreground_pixel;
    gcvalues.plane_mask = background_pixel ^ foreground_pixel;
    gcmask = GCForeground | GCFunction | GCPlaneMask;
    XChangeGC(display, current_preedit_font->invert_gc, gcmask, &gcvalues);
#ifdef	XSF_X11R5
    gcmask = GCBackground | GCForeground ;
    gcvalues.foreground = foreground_pixel;
    gcvalues.background = background_pixel;
    reverse_gcvalues.foreground = background_pixel;
    reverse_gcvalues.background = foreground_pixel;

    XChangeGC(display, current_preedit_font->normal_gc, gcmask, &gcvalues);
    XChangeGC(display, current_preedit_font->reverse_gc, gcmask,
	      &reverse_gcvalues);
#endif	/* XSF_X11R5 */
    return (0);
}

int
FXTextWidth(current_preedit_font, input_data, length)
    FXimpFont      *current_preedit_font;
    ushort         *input_data;
    int             length;
{
    int             j, width = 0;
    for (j = length; j > 0; j--, input_data++) {
	width += (*input_data > 0xff) ?
	    current_preedit_font->kanji_font_width :
	    current_preedit_font->ascii_kana_font_width;
	/** !! Not suported valiable width fonts !! */
    }
    return (width);
}

#ifndef	XSF_X11R5
int
FXTextExtentsArea(current_preedit_font, preedit, input_data, length,
		  ret_area, ret_len, ret_lineno)
    FXimpFont      *current_preedit_font;
    Ximp_PreeditPropRec *preedit;
    ushort         *input_data;
    int             length;
    XRectangle     *ret_area;
    short          *ret_len;
    int            *ret_lineno;
{
    int             j, x2, y2;
    int             sy, over = 0;
    int             area_no = 0;
    int             x, y, width, height;
    int             max_x2;
    int             edit_x1, edit_y1, edit_x2, edit_y2;
    ushort          save, *savep;

    savep = &input_data[length];
    save = *savep;
    *savep = 0xA1A1;

    edit_x1 = preedit->Area.x;
    edit_y1 = preedit->Area.y;
    edit_x2 = edit_x1 + preedit->Area.width;
    edit_y2 = edit_y1 + preedit->Area.height;

    width = 0;
    max_x2 = 0;
    height = current_preedit_font->max_font_height;
    x = preedit->SpotLocation.x;
    y = preedit->SpotLocation.y - current_preedit_font->max_font_ascent;
    if (x < edit_x1)
	x = edit_x1;
    if (x > edit_x2) {
	x = edit_x1;
	y = y + preedit->LineSpacing;
    }
    if (y < edit_y1)
	y = edit_y1;
    if (preedit->SpotLocation.y > edit_y2)
	y = edit_y1;
    sy = y;
    x2 = x;
    y2 = y + height;

    ret_len[0] = 0;
    ret_len[1] = 0;
    *ret_lineno = 0;

    for (j = length + 1; j > 0; j--, input_data++) {
	width = FXTextWidth(current_preedit_font, input_data, 1);
	if ((x2 + width) <= edit_x2) {
	    x2 = x2 + width;
	} else {		/* over	width		 */
	    if (*ret_len) {	/* kanji_data exist ?	 */
		(*ret_lineno)++;/* count line no.	 */
		area_no++;
		ret_area->x = x;
		ret_area->y = y;
		ret_area->width = x2 - x;
		ret_area->height = y2 - y;
		ret_area++;	/* next_item ret_area (max 2) */
		if (area_no >= 2) {
		    *savep = save;
		    return (area_no);	/* area over !!		 */
		}
		ret_len++;
	    }
	    x = edit_x1;
	    y = y2 + preedit->LineSpacing - height;
	    x2 = x + width;
	    y2 = y2 + preedit->LineSpacing;
	    if (y2 > edit_y2) {
		y = edit_y1;
		y2 = y + height;
	    }
	}
	(*ret_len)++;		/* count String length	 */
    }

    if (*ret_len) {		/* kanji_data exist ?	 */
	(*ret_lineno)++;	/* count line no.	 */
	area_no++;
	ret_area->x = x;
	ret_area->y = y;
	ret_area->width = x2 - x;
	ret_area->height = y2 - y;
    }
    *savep = save;
    return (area_no);
}
#endif	/* not XSF_X11R5 */

FXDrawImageString(display, window, current_preedit_font,
		  reverse, x, y, buff, length, mode)
    Display        *display;
    Window          window;
    FXimpFont      *current_preedit_font;
    int             reverse;
    int             x, y;
    ushort         *buff;
    int             length;
    int		    mode;
{
    GC              gc, ascii_kana_gc, kanji_gc, gaiji_gc;
    int             sv_x = x;
    unsigned int    c2, cmask, ctype;
    ushort         *buff_end;
    unsigned char  *outp, *out_end;
#define outbufsize 256
    unsigned char   outbuf[outbufsize];

    if (!reverse) {
	ascii_kana_gc = current_preedit_font->ascii_kana_gc;
	kanji_gc = current_preedit_font->kanji_gc;
	gaiji_gc = current_preedit_font->gaiji_gc;
    } else {
	ascii_kana_gc = current_preedit_font->ascii_kana_reverse_gc;
	kanji_gc = current_preedit_font->kanji_reverse_gc;
	gaiji_gc = current_preedit_font->gaiji_reverse_gc;
    }

    outp = outbuf;
    out_end = outbuf + outbufsize - 2;
    buff_end = buff + length;

    while (buff < buff_end) {
	ctype = *buff & 0x8080;
	switch (ctype) {
	case 0x0000:
	    gc = ascii_kana_gc;
	    cmask = 0x007f;
	    break;
	case 0x0080:
	    gc = ascii_kana_gc;
	    cmask = 0x00ff;
	    break;
	case 0x8080:
	    gc = kanji_gc;
	    cmask = 0x7f7f;
	    break;
	case 0x8000:
	    gc = gaiji_gc;
	    cmask = 0x7f7f;
	    break;
	}

	if (!gc) {
	    while ((buff < buff_end)
		   && ((*buff & 0x8080) == ctype)) {
		buff++;
	    }
	} else
	    while ((buff < buff_end)
		   && (outp < out_end)
		   && (((c2 = *buff) & 0x8080) == ctype)) {
		if (cmask & 0x7f00) {
		    *outp++ = (c2 & cmask) >> 8;
		    *outp++ = c2 & 0x007f;
		} else {
		    *outp++ = c2 & cmask;
		}
		buff++;
	    }

	length = outp - outbuf;
	if (length > 0) {
	    if (cmask & 0x7f00) {
		length = length / 2;
		XDrawImageString16(display, window, gc, x, y,
				   (XChar2b *) outbuf, length);
		x += current_preedit_font->kanji_font_width * length;
	    } else {
		XDrawImageString(display, window, gc, x, y,
				 (char *) outbuf, length);
		x += current_preedit_font->ascii_kana_font_width * length;
	    }
	    outp = outbuf;
	}
    }
    return (x - sv_x);
}

#endif	/* USE_X11R5_LIB */

extern void
MakePreeditInfo(display,  current_client, preedit_attr,
		    preedit_font, preedit_window_info, mode, max_preedit_line )
    Display		*display;
    FXimp_Client	*current_client;
    Ximp_PreeditPropRec	*preedit_attr;
    FXimpFont		*preedit_font;
    Htt_PreeditWinRec  **preedit_window_info;
    int			 mode ;
    int			 max_preedit_line;
{
    Htt_PreeditWinRec	*preedit_winfo;
    Htt_PreeditWinRec   *pinfo;
    Htt_PreeditWinRec	*back_link;
    int			 x1, y1, x2, y2;
    long		 xx, yy;
    int			 ntimes;
    int			 ntimes2;
    Bool                 zero_line = False;
    Bool		 first = True;
    int			 npinfo;

#ifdef DEBUG
    dbg_printf("** MakePreeditInfo **\n" );
#endif					/* DEBUG */
    x1 = preedit_attr->Area.x;
    y1 = preedit_attr->Area.y;
    x2 = preedit_attr->Area.x + preedit_attr->Area.width;
    y2 = preedit_attr->Area.y + preedit_attr->Area.height;

    xx = preedit_attr->SpotLocation.x;
    yy = preedit_attr->SpotLocation.y - preedit_font->max_font_ascent;

    if ( xx < x1 )
	xx = x1;
    if ( xx > x2 - preedit_font->max_font_width ) {
	xx = x1;
	yy += preedit_attr->LineSpacing;
    }
    if ( yy < y1 ) {
	xx = x1;
	yy = y1;
    }
    if ( yy > y2 - preedit_attr->LineSpacing ) {
	xx = x1;
	yy = y1;
    }

    ntimes = ( y2 - yy ) / preedit_attr->LineSpacing;
    ntimes2 = ( y2 - yy ) % preedit_attr->LineSpacing;
    if ( ntimes2 >= preedit_font->max_font_height )
	ntimes++;
    if ( max_preedit_line != 0 )
	ntimes = MIN( max_preedit_line, ntimes );
    back_link = NULL;
    preedit_winfo = *preedit_window_info;
#ifdef DEBUG
    dbg_printf("    xx=%d yy=%d x1=%d y1=%d x2=%d y2=%d ntimes=%d\n",
		xx, yy, x1, y1, x2, y2, ntimes );
#endif					/* DEBUG */

    if( ntimes == 0 ) {
        ntimes = 1;
        zero_line = True;
    }

    pinfo = preedit_winfo;
    npinfo = (current_client->style & XIMPreeditNothing) ?
	   GET_HTT_VALUE(htt, ims_preedit_line)
	   : max_preedit_line;
    for ( ; npinfo > 0; npinfo-- , ntimes--) {
	if ( !pinfo ) {
	    pinfo = (Htt_PreeditWinRec *)malloc( sizeof(Htt_PreeditWinRec) );
	    bzero( pinfo, sizeof(Htt_PreeditWinRec) );
	}
	if(first) {
		preedit_winfo = pinfo;
		first = False;
	}
	if(yy > y2 - preedit_font->max_font_height)
		yy = preedit_attr->Area.y;
	pinfo->back_link = (struct _Htt_PreeditWinRec *)back_link;
	pinfo->area_part.x = xx;
	pinfo->area_part.y = yy;
	pinfo->area_part.width  = x2 - xx;
	if(zero_line)
		pinfo->area_part.height = y2 - y1;
	else
		pinfo->area_part.height = preedit_attr->LineSpacing;
	pinfo->status |= PREEDITWIN_MODIFY;
	if ( mode )
	    pinfo->status |= mode;
	if (  ( current_client->style & XIMPreeditPosition )
	   && !( mode & PREEDITWIN_ROOT ) ) {
	    pinfo->old_width  =
			preedit_font->max_font_width * pinfo->draw_char_len;
	    pinfo->current_width  =
			preedit_font->max_font_width * pinfo->draw_char_len;
	} else {
	    pinfo->old_width  = pinfo->area_part.width;
	    pinfo->current_width  = pinfo->area_part.width;
	}

	if(pinfo->back_link)
		pinfo->back_link->next_link = pinfo;
	back_link = pinfo;
	pinfo = pinfo->next_link;

	xx = x1;
	yy += preedit_attr->LineSpacing;
    }
    if(pinfo)
    	DisablePreeditInfo(display, pinfo);
    else if(back_link)
    	back_link->next_link = (struct _Htt_PreeditWinRec *)NULL;
    *preedit_window_info = preedit_winfo;

    if ( ( current_client->style & XIMPreeditPosition )
      && ( (*preedit_window_info)->current_width == 0 ) )
	(*preedit_window_info)->current_width = 1;
    return;
}

extern void
CopyPreeditInfo(display, to_client, from_client )
    Display		*display;
    FXimp_Client	*to_client;
    FXimp_Client	*from_client;
{
    Htt_PreeditWinRec	*to_winfo, *from_winfo, *back_winfo;

    DestroyPreeditInfo(display, to_client->preedit_window_info );
    to_client->preedit_window_info = NULL;

    to_winfo   = (Htt_PreeditWinRec *)&to_client->preedit_window_info;
    from_winfo = from_client->preedit_window_info;
    back_winfo = NULL;

    for ( ; from_winfo;
		from_winfo = (Htt_PreeditWinRec *)from_winfo->next_link ) {
	to_winfo->next_link = (struct _Htt_PreeditWinRec *)
					malloc( sizeof(Htt_PreeditWinRec) );
	bcopy( from_winfo, to_winfo->next_link, sizeof(Htt_PreeditWinRec) );
	to_winfo->next_link->back_link = back_winfo;
	to_winfo = (Htt_PreeditWinRec *)to_winfo->next_link;
	to_winfo->status |= PREEDITWIN_LINKED;
	back_winfo = to_winfo;
    }
    return;
}

extern Htt_PreeditWinRec *
LinkPreeditInfo( top_winfo, link_winfo )
    Htt_PreeditWinRec	*top_winfo;
    Htt_PreeditWinRec	*link_winfo;
{
    Htt_PreeditWinRec	*last_winfo = top_winfo;
#ifdef	DEBUG
	dbg_printf( "*** LinkPreeditInfo ***\n" );
#endif

    if ( last_winfo == NULL )
	return ( link_winfo );
    if ( link_winfo == NULL )
	return ( top_winfo );

    for ( ; last_winfo->next_link != NULL; last_winfo = last_winfo->next_link ){
#ifdef	DEBUG
	dbg_printf( "last_winfo=%8.8x, next=%8.8x, back=%8.8x\n",
		last_winfo, last_winfo->next_link, last_winfo->back_link);
#endif
    }
    last_winfo->next_link = link_winfo;
    link_winfo->back_link = last_winfo;
    return ( top_winfo );
}

extern void
DestroyPreeditInfo(display, winfo )
    Display	        *display;
    Htt_PreeditWinRec	*winfo;
{
    Htt_PreeditWinRec	*ninfo;

    for ( ninfo = winfo; ninfo; winfo = ninfo ) {
	if ( ( winfo->status & PREEDITWIN_CREATE )
	  && ( !(winfo->status & PREEDITWIN_LINKED) ) )
	    XDestroyWindow( display, winfo->win_part );
	ninfo = winfo->next_link;
	free( winfo );
    }
    return;
}

static void
DisablePreeditInfo(display, winfo)
    Display	        *display;
    Htt_PreeditWinRec	*winfo;
{
    Htt_PreeditWinRec	*ninfo;

    for ( ninfo = winfo; ninfo; winfo = ninfo ) {
	if ( ( winfo->status & PREEDITWIN_CREATE )
	  && ( !(winfo->status & PREEDITWIN_LINKED) ) ) {
	    XUnmapWindow( display, winfo->win_part );
	    winfo->status &= ~PREEDITWIN_MAP;
	}
	ninfo = winfo->next_link;
    }
    return;
}

extern void
FXDrawRectangle( display, window, current_preedit_font, x, y, width, height )
    Display		*display;
    Window		 window;
    FXimpFont		*current_preedit_font;
    int			 x, y;
    unsigned int	 width, height;
{
    XDrawRectangle( display, window,
			current_preedit_font->normal_gc, x, y, width, height );
    return;
}

extern void
FXDrawImageChar( display, window, current_preedit_font,
			attr, x, y, buff, width, mode )
    Display	*display;
    Window	 window;
    FXimpFont	*current_preedit_font;
    XIMFeedback	*attr;
    int		 x, y;
    wchar_t	*buff;
    int		 width;
    int		mode;
{
    GC		 gc ;
    FXimp_Client   *focus_in_client= GET_HTT_VALUE(htt, focus_in_client);

    if ( *attr == XIMReverse ) {
	gc = current_preedit_font->reverse_gc ;
    } else {
	gc = current_preedit_font->normal_gc ;
    }
    if (mode == stipple) {
        stipple_pixmap = XCreatePixmapFromBitmapData(display,
                window, pattern_bits, 8, 8,
                gc->values.background, gc->values.foreground, 1);
        XSetStipple (display, gc, stipple_pixmap);
        XSetFillStyle (display, gc, FillOpaqueStippled);
        XwcDrawString( display, window,
             current_preedit_font->font_set, gc, x, y, buff, 1 );
        XSetFillStyle(display, gc, FillSolid);
        XFreePixmap(display, stipple_pixmap);
    }
    else {
      XwcDrawImageString( display, window,
			current_preedit_font->font_set, gc, x, y, buff, 1 ) ;
    }

    if ( *attr == XIMUnderline )
	XDrawLine( display, window, current_preedit_font->normal_gc,
			x, y + current_preedit_font->max_font_descent,
			x + width,
			y + current_preedit_font->max_font_descent );
    return;
}


unsigned long
GetPixelByName(display, cmap, name, def)
    Display	*display;
    Colormap	cmap;
    char	*name;
    unsigned long	def;
{
    XColor	screen_def_return, exact_def_return;

    if(!name)
	return def;
    if (XAllocNamedColor(display, cmap, name, 
			&screen_def_return, &exact_def_return))
		return screen_def_return.pixel;
    else {
	ErrorMessage(10, name);
	return def;
    }
}


void
HttDrawXIMString(display, w, ximp_font, fb, x, y, wstr, len, mode)
    Display	*display;
    Window	w;
    FXimpFont	*ximp_font;
    XIMFeedback	*fb;
    int		x, y;
    wchar_t	*wstr;
    int		len;
    int		mode;
{
    XIMFeedback	*f1 = fb;
    XIMFeedback	*f2;
    int		relen = len;
    int		fg_len;
    int		width;
    XFontSet	fontset = ximp_font->font_set;
    GC		gc	= ximp_font->normal_gc;
    GC		rgc	= ximp_font->reverse_gc;
    XGCValues   gcv;

    if(mode == stipple) {
	XGetGCValues(display, gc, GCForeground | GCBackground, &gcv);
        stipple_pixmap = XCreatePixmapFromBitmapData(display,
                w, (char *)pattern_bits, 8, 8,
                gcv.background, gcv.foreground, 1);
        XSetStipple(display, gc, stipple_pixmap);
        XSetFillStyle(display, gc, FillOpaqueStippled);
        XSetStipple(display, rgc, stipple_pixmap);
        XSetFillStyle(display, rgc, FillOpaqueStippled);
    }

    if(!fb)
	XwcDrawString(display, w, fontset, gc, x, y, wstr, len);
    else {
        while(relen) {
	    f2 = f1;
	    while(*f2 == *f1 && relen) {
		f2++;
		relen--;
	    }
	    fg_len = len - relen;
	    if(*f1 & XIMReverse)
	        XwcDrawImageString(display, w, fontset, rgc, x, y, wstr, fg_len);
	    else
	        XwcDrawString(display, w, fontset, gc, x, y, wstr, fg_len);
	    width = XwcTextEscapement(fontset, wstr, fg_len);
	    if(*f1 & XIMUnderline)
	        XDrawLine(display, w, gc, x, y+1, x + width, y+1);
	    wstr += fg_len;
	    x += width;
	    f1 = f2;
	    len = relen;
        }
    }

    if(mode == stipple) {
        XSetFillStyle(display, gc, FillSolid);
        XSetFillStyle(display, rgc, FillSolid);
        XFreePixmap(display, stipple_pixmap);
    }
}
