/****************************************************************************

              Copyright 1992, by Sun Microsystems, Inc.	      

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

****************************************************************************/

#ifndef lint
#ifdef sccs
static char     sccsid[] = "@(#)HttLkup.h	1.9 93/02/21 SMI";
#endif
#endif


#ifndef _HTT_LKUP_H_
#define _HTT_LKUP_H_

typedef	struct _LookupInfo {
    char	*font_name;
    char	*background_color;
    char	*foreground_color;
    int         style;
    int         navigation;
    int         nrows;
    int         ncolumns;
    int         wspacing1;
    int         wspacing2;
    int         hspacing;
    int         linewidth;
    int         borderwidth;
    int		navigator;   /* To get the position of LookupChoice */
    int		off_x;	 /* offset from the specified position */
    int		off_y;
    int		next_to;	 /* LUC should be attached to ... 	*/
    XFontSet   	fontset;
    XFontSetExtents	*font_ext;
    GC		*gc;
    GC		*rgc;
    wchar_t     constant_next[16];
    wchar_t     constant_prior[16];
    int		num_win;
    Window      *luc_win;
    int		base_index;
    int		label_type;
    char	*title;
    int		move;
    int		save_under;
    int		title_pos;
    int		lock;
    Bool	wmhits;
    XPointer	special;	/* reserved for each style of LUC */
} LookupInfo, *LucRec;

#define	LUC_LOOKUP_INFO		"LUC_lookup_info"
#define LUC_LAYOUT		"LUC_layout"

/*
 * lookup_menu's define
 */
#define	LOOKUP_MENU_POPUPWINDOW       0
#define	LOOKUP_MENU_IMSWINDOW         1
#define	LOOKUP_MENU_IMSWINDOW2        2
#define	LOOKUP_MENU_GORGEOUS	      3

#define	LOOKUP_POSITION_MOUSE	1
#define	LOOKUP_POSITION_WINDOW	2

#define	LOOKUP_NEXT_TO_RIGHT	1
#define LOOKUP_NEXT_TO_BOTTOM	2
#define	LOOKUP_NEXT_TO_LEFT	3
#define	LOOKUP_NEXT_TO_TOP	4

#endif	_HTT_LKUP_H_
