#ifndef lint
#ifdef sccs
static char     sccsid[] = "@(#)XSunIMSj3.h	1.01 92/06/02 SMI";
#endif
#endif

/*
****************************************************************************

              Copyright 1991, by FUJITSU LIMITED
              Copyright 1991, by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED and Sun
Microsystems, Inc. not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. makes no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Riki Kawaguchi	FUJITSU LIMITED
        Hideki Hiura    Sun Microsystems, Inc.

****************************************************************************
*/

#ifndef xim_imlogic_sj3_DEFINED
#define xim_imlogic_sj3_DEFINED

#define	SJ3_IF_VERSION		"0.1"
#define SJ3_IF_LE_NAME		"sj3"
#define	SJ3_MAX_ASCIISTRING	128
#define MAX_BUNSETU		512
#define	KANJI_BUFF_SIZE		512

/* sj3 status */
#define SJ3Status_MAX_COLUMS	64
#define SJ3Status_MAX_NUM	4
#define	SJ3Status_CONVOFF	0
#define	SJ3Status_HIRAGANA	1
#define	SJ3Status_KATAKANA	2
#define	SJ3Status_ALFANUM	3

/* sj3 status strings */
#define SJ3String_CONVOFF	{0xccb5,0xcad1,0xb4b9,0}
#define SJ3String_HIRAGANA	{0xc1b4,0xb3d1,0xa1a7,0xcabf,0xb2be,0xccbe,0}
#define SJ3String_KATAKANA	{0xc1b4,0xb3d1,0xa1a7,0xcad2,0xb2be,0xccbe,0}
#define SJ3String_ALFANUM	{0xc1b4,0xb3d1,0xa1a7,0xb1d1,0xbff4,0xbbfa,0}

#define SJ3_STRING_ALLOC_SIZE	32

#ifndef MB_LEN_MAX
#define MB_LEN_MAX	4
#endif

typedef struct	_sj3_feedback {
    XIMFeedback		*feedback;
    short		 use_count;
    short		 alloc_count;
} sj3_feedback;

typedef struct	_sj3_bunsetu {
    struct bunsetu	*bun;
    short		 use_count;
    short		 count;
} sj3_bunsetu;

typedef struct	_sj3_douon {
    struct douon	*douon;
    short		 use_count;
    short		 count;
} sj3_douon;

typedef struct	_sj3_EUCstring {
    wchar_t		*string;
    short		 use_count;
    short		 count;
} sj3_EUCstring;

typedef struct	_sj3_SJISstring {
    String		 string;
    short		 use_byte;
    short		 area_size;
} sj3_SJISstring;

typedef struct	_iml_session {
/*      im-logic base class */
#define xim_iml_inheritance_DEFIND
#include "XSunIMCore.h"
#undef  xim_iml_inheritance_DEFIND
/*      Derived class */
    HttTCid		 tc;
    int			 convMode;
    int			 bnum;
    int			 current_bnum;
    int			 num_of_conved;
    Boolean		 is_lookup;
    sj3_SJISstring	 romaString;
    sj3_SJISstring	 convString;
    sj3_bunsetu		 bunsetu;
    sj3_douon		 douon;
    sj3_EUCstring	 preeditString;
    sj3_feedback	 preeditFeedback;
} iml_session_t;

#define SmallTSU	0xa4c3
#define	NN		0xa4f3

#define	Z_NONE	0
static unsigned short	hankakuToZenkakuTbl[] = {
    Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, /* 00-07 */
    Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, /* 08-0f */
    Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, /* 10-17 */
    Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, Z_NONE, /* 18-1f */
    0xa1a1, 0xa1aa, 0xa1af, 0xa1f4, 0xa1f0, 0xa1f3, 0xa1f5, 0xa1ec, /* 20-27 */
    0xa1ca, 0xa1cb, 0xa1f6, 0xa1dc, 0xa1a4, 0xa1bd, 0xa1a5, 0xa1bf, /* 28-2f */
    0xa3b0, 0xa3b1, 0xa3b2, 0xa3b3, 0xa3b4, 0xa3b5, 0xa3b6, 0xa3b7, /* 30-37 */
    0xa3b8, 0xa3b9, 0xa1a7, 0xa1a8, 0xa1e3, 0xa1e1, 0xa1e4, 0xa1a9, /* 38-3f */
    0xa1f7, 0xa3c1, 0xa3c2, 0xa3c3, 0xa3c4, 0xa3c5, 0xa3c6, 0xa3c7, /* 40-47 */
    0xa3c8, 0xa3c9, 0xa3ca, 0xa3cb, 0xa3cc, 0xa3cd, 0xa3ce, 0xa3cf, /* 48-4f */
    0xa3d0, 0xa3d1, 0xa3d2, 0xa3d3, 0xa3d4, 0xa3d5, 0xa3d6, 0xa3d7, /* 50-57 */
    0xa3d8, 0xa3d9, 0xa3da, 0xa1ce, 0xa1ef, 0xa1cf, 0xa1b0, 0xa1b2, /* 58-5f */
    0xa1a2, 0xa3e1, 0xa3e2, 0xa3e3, 0xa3e4, 0xa3e5, 0xa3e6, 0xa3e7, /* 60-67 */
    0xa3e8, 0xa3e9, 0xa3ea, 0xa3eb, 0xa3ec, 0xa3ed, 0xa3ee, 0xa3ef, /* 68-6f */
    0xa3f0, 0xa3f1, 0xa3f2, 0xa3f3, 0xa3f4, 0xa3f5, 0xa3f6, 0xa3f7, /* 70-77 */
    0xa3f8, 0xa3f9, 0xa3fa, 0xa1d0, 0xa1c3, 0xa1d1, 0xa1c1, Z_NONE, /* 78-7f */
};

#define GetZenkaku(c)		(hankakuToZenkakuTbl[(c)])
#define DelSJISString(roma)	{ \
			(roma)->use_byte -= sizeof(unsigned short); \
			(roma)->string[(roma)->use_byte] = '\0'; \
	}
#define	DelPreeditString(preedit)	{ \
			(preedit)->use_count--; \
			(preedit)->string[(preedit)->use_count] = (wchar_t)0; \
	}
#define	DisplayPreedit(s,rrv,lp)	{ \
			(lp) = s->If->m->iml_make_preedit_draw_inst( \
				(s), (s)->preeditString.string, \
				(s)->preeditFeedback.feedback ); \
			s->If->m->iml_link_inst_tail( &(rrv), (lp) ); \
			if ( (lp) = (s)->If->m->iml_execute( (s), &(rrv) ) ) \
			    sj3x_eval_results( (s), (lp) ); \
	}
#define	DelFeedback(feedback)	(feedback)->use_count--;
#define	Is_notConved(s)	( (s)->num_of_conved == 0 && (s)->current_bnum == 0 )
#define Is_conved(s)	( (s)->num_of_conved != 0 || (s)->current_bnum != 0 )
#define Is_foundNonCommitStrings(s)	( (s)->preeditString.use_count != 0 )
#define Is_foundConversionStrings(s)	( (s)->romaString.use_byte != 0 )
#define Is_lookupMode(s)	(s)->is_lookup
#define NumOfDouon(s)		( s->douon.use_count )
#define GetStatus(s)		StatusString[(s)->convMode]

#endif	/* xim_imlogic_sj3_DEFINED */
